/*
 * TIR16A_open_source.c
 * Lens 형
 * Created: 2020-01-22 오후 1:14:34
 * Author: 강건일 / www.avmar.co.kr
 */ 

#include <avr/io.h>
#include <stdio.h>
#include <avr/io.h>
#include <math.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#define  N_CHANNEL   4 //from 4
#define setup  10       // setup delay 변경함
void msec_delay (int n);

int main(void)
{
    int adresult[N_CHANNEL];        
    int i;
    int j ; 
    long int thg, tp1, tp2, tp3, ref0, ref1, ref2, ref3,ref01, ref4, ref5, ref11, ref21, ref31,ref41,ref22, ref23;
        
    DDRC = 0xFF; 
    PORTC |= 0xF0 ;     
    DDRA = 0x00;    
    
    for(j=0; j<setup ; j++)  
    {
	    	   
	    PORTC = 0xCF;
	    msec_delay(5000);
	    
	    PORTC = 0xFF; 
	    msec_delay(5000);
	    
	    PORTC = 0xEF;
	    msec_delay(5000);
	    
	    PORTC = 0xDF;
	    msec_delay(5000);   
	   	    
	    PORTC = 0xFF;	    
    }
    
    sei ();
    ADCSRA = (1<<ADEN) | (7<<ADPS0) ;
    
    while(1)
    {	     
	   
	    for ( i=0; i<N_CHANNEL;i++)
	    {
		    ADMUX = (1<<REFS0) | (i<<MUX0);  // 내부2.56v 일때3 그리고 5v일때는 1임, .
		   		    
		    ADCSRA |= (1<<ADSC); // AD 변환 시작
		    
		    while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림
		    
		    ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
		    adresult[i] = ADC;
		    
		    adresult[i] = adresult[i] * 5 ;	  
		   		    
		    ref3 =  adresult[3]; 
		    
		    ref2 =  adresult[2];  // FP2 ,Tp2 2차 amp 출력 값,
		    
		    ref1 =  adresult[1]; 
		    
		    ref0 =  adresult[0];  
		    
	    }
	    	    
	    msec_delay(800);  	    
	    
	    if ((ref21 + 17) <= adresult[2])  	    
	    
	    PORTC = 0x5F ;
	    msec_delay(20);	    
	    
	    if ((ref21 - 12) >= adresult[2]) 
	    PORTC = 0xEF;
	    msec_delay(20);
	    
	    
	    for ( i=0; i<N_CHANNEL;i++)
	    {
		    ADMUX = (1<<REFS0) | (i<<MUX0);  
		    		    
		    ADCSRA |= (1<<ADSC); // AD 변환 시작
		    
		    while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림
		    
		    ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
		    adresult[i] = ADC;		    
		    
		    adresult[i] = adresult[i] * 5 ;
		   
		    ref21 =  adresult[2];  // FP2 ,Tp2 2차 amp 출력 값, RED Led PB5
	    }	         
	    
	    if ((ref2 + 17) <= adresult[2])	    
	    PORTC = 0x5F; 
	    msec_delay(20);	    
	    
	    if ((ref2 - 12) >= adresult[2])
	    PORTC = 0xEF; 
	    msec_delay(20);	    
	    
	    msec_delay(800); 	
	    
	    ref0=0x000;
	    ref1=0x000;
	    ref3=0x000;
	    ref4=0x000;
	    ref5=0x000;	    
	    
          }
    }
        
    void msec_delay (int n)
    {
	    for (; n>0; n--)
	    _delay_ms(1);  // 시간 지연하려면 (2)로 한다
	    
       }